//========================================================================================
// "   "
//    (CornerBorder.js)
//
//  1.0
//
//             
//    (Corner Effects...)
//
// *************************    **************************************
//           
//         , ..     
//
// 1.1  
//
// 1.2    
//
// 1.3    :      -   
//       ,       -    
//     .
//
// :   (ragman)
//
// : 04.04.2005 .
//
//=========================================================================================
var scriptName = "   ";
var scriptVer = " 1.3";

// 
var myParagraphStyle = "";
var myCornerEffect = "rounded";
var myCornerRadius = "5";
var myStyleLine = "Solid";
var myColorLine = "Black";
var myStrokeWeight = 1;
var myInsetSpacing = "1";

function cornerRound (myTextFrame, myPage) {

	//    
	for (myCounter = 0; myCounter < myTextFrame.paragraphs.length; myCounter++) {
		myPara = myTextFrame.paragraphs[myCounter];
		if (myPara.appliedParagraphStyle.name == myParagraphStyle){
			//     
			var myText = myPara.characters.itemByRange(0, (myPara.characters.length - 2));
			myText.select(SelectionOptions.replace);
			app.cut();
			//     0
			myPara.firstLineIndent = 0;
			myPara.leftIndent = 0;
			myPara.leading = -1;
			//  
			var columnWidth = myTextFrame.textFramePreferences.textColumnFixedWidth;
			//       
			var myNewTextFrame = myPage.textFrames.add();
			with (myNewTextFrame) {
				strokeWeight = myStrokeWeight;
				strokeType = myStyleLine;
				strokeColor = myColorLine;
				//geometricBounds [y1, x1, y2, x2]
				geometricBounds = [0, 0, 100, columnWidth];
				textFramePreferences.insetSpacing = new Array(myInsetSpacing, myInsetSpacing, myInsetSpacing, myInsetSpacing);
				cornerEffect = myCornerEffect;
				cornerRadius = myCornerRadius;
				insertionPoints[0].select(SelectionOptions.replace);
				app.paste();
				fit(given = 1718906723);
				geometricBounds = [geometricBounds[0], geometricBounds[1], geometricBounds[2], columnWidth];
			}
			
			//     
			myNewTextFrame.select(SelectionOptions.replace);
			app.cut();
			myPara.insertionPoints[0].select(SelectionOptions.replace);
			app.paste();
		}
	}
}


with (app) {
	//,    
	if ((selection.length == 1)&&((selection[0].constructor.name == "TextFrame") || selection[0].constructor.name == "InsertionPoint")) {
	} else {
		alert("    ");
		exit();
	}
	
	var myDoc = activeDocument;
	
	//   	
	var myStyleNames = new Array();
	var mySelectIndexStyle = 0;
	for (myCounter = 0; myCounter < myDoc.paragraphStyles.length; myCounter++) {
		myStyleNames[myCounter] = myDoc.paragraphStyles[myCounter].name;
		if (myStyleNames[myCounter] == myParagraphStyle) {
			mySelectIndexStyle = myCounter;
		}
	}
	
	//    
	var myCornerEffectList = new Array ("none", "rounded", "inverse rounded", "inset", "bevel", "fancy");
	var myCornerEffectValue = new Array (1852796517, 1667592804, 1667591798, 1667591795, 1667588726, 1667589742);
	var mySelectIndexCorner = 0;
	for (myCounter = 0; myCounter < myCornerEffectList.length; myCounter++) {
		if (myCornerEffectList[myCounter] == myCornerEffect) {
			mySelectIndexCorner = myCounter;
		}
	}

	//   
	var myStyleLineName = new Array();
	var mySelectIndexStyleLine = 0;
	for (myCounter = 0; myCounter < myDoc.strokeStyles.length; myCounter++) {
		myStyleLineName[myCounter] = myDoc.strokeStyles[myCounter].name;
		if (myStyleLineName[myCounter] == myStyleLine) {
			mySelectIndexStyleLine = myCounter;
		}
	}
	
	//     
	var myColorSwatchesName = new Array();
	var mySelectIndexColor = 0;
	for (myCounter = 0; myCounter < myDoc.swatches.length; myCounter++) {
		myColorSwatchesName[myCounter] = myDoc.swatches.item(myCounter).name;
		if (myColorSwatchesName[myCounter] == myColorLine) {
			mySelectIndexColor = myCounter;
		}
	}


//  
	//  
	var myDialog = dialogs.add({name:scriptName + scriptVer});
	// 
	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add().borderPanels.add()) {
			with (dialogColumns.add()) {
				dialogRows.add().staticTexts.add({staticLabel:" "});
				dialogRows.add().staticTexts.add({staticLabel:" "});
				dialogRows.add().staticTexts.add({staticLabel:" "});
				dialogRows.add().staticTexts.add({staticLabel:" "});
				dialogRows.add().staticTexts.add({staticLabel:" "});
				dialogRows.add().staticTexts.add({staticLabel:" "});
				dialogRows.add().staticTexts.add({staticLabel:" "});
			}
			with (dialogColumns.add()) {
				var mySelectStyle = dialogRows.add().dropdowns.add({stringList:myStyleNames, selectedIndex:mySelectIndexStyle});
				var mySelectCorner = dialogRows.add().dropdowns.add({stringList:myCornerEffectList, selectedIndex:mySelectIndexCorner});
				var mySelectCornerRadius = dialogRows.add().measurementEditboxes.add({editContents:myCornerRadius, editUnits:2053991795}); //
				var mySelectInsetSpacing = dialogRows.add().measurementEditboxes.add({editContents:myInsetSpacing, editUnits:2053991795});
				var mySelectStyleLine = dialogRows.add().dropdowns.add({stringList:myStyleLineName, selectedIndex:mySelectIndexStyleLine});
				var mySelectStrokeWeight = dialogRows.add().measurementEditboxes.add({editValue:myStrokeWeight, editUnits:2054188905});
				var mySelectColor = dialogRows.add().dropdowns.add({stringList:myColorSwatchesName, selectedIndex:mySelectIndexColor});
			}
		}
		with (dialogRows.add()) {
			dialogColumns.add().staticTexts.add({staticLabel:"      ragman_mail@front.ru"});
		}
	}
	// 
	var myResult = myDialog.show();
	if (!myResult) {
		myDialog.destroy();
		exit();
	}
	
	myParagraphStyle = myDoc.paragraphStyles[mySelectStyle.selectedIndex].name;
	myCornerEffect = myCornerEffectValue[mySelectCorner.selectedIndex];
	myCornerRadius = Number (mySelectCornerRadius.editContents);
	myStyleLine = myStyleLineName[mySelectStyleLine.selectedIndex];
	myStrokeWeight = mySelectStrokeWeight.editValue;
	myColorLine = myDoc.swatches.item(myColorSwatchesName[mySelectColor.selectedIndex]);
	myInsetSpacing = mySelectInsetSpacing.editContents;

	// 
	switch (selection[0].constructor.name) {
		case "InsertionPoint":
			var myStory = selection[0].parentStory;
			break;
		case "TextFrame":
			var myStory = false;
	}
//	var myStory = selection[0].parentStory;
	if (myStory) {
		for (myTextFramesCount = 0; myTextFramesCount < myStory.textFrames.length; myTextFramesCount++) {
			var myTextFrame = myStory.textFrames[myTextFramesCount];
			var pageNum = myTextFrame.parent.id;
			var myPage = activeDocument.pages.itemByID(pageNum);
			cornerRound (myTextFrame, myPage)
		}
	}
	else {
		myTextFrame = selection[0];
		var pageNum = myTextFrame.parent.id;
		var myPage = activeDocument.pages.itemByID(pageNum);
		cornerRound (myTextFrame, myPage)
	}
}
